// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.
package models

import (
	"errors"
	"leit.com/aps_engine/db"
	"time"
	"xorm.io/core"
)

type OmWooperationqtyreclst struct {
	Plantnr              int       `json:"PlantNr" xorm:"not null pk INT(4)"`
	Workorderid          string    `json:"WorkOrderId" xorm:"not null pk NVARCHAR(80)"`
	Operationnr          int       `json:"OperationNr" xorm:"not null pk INT(4)"`
	Splitnr              int       `json:"SplitNr" xorm:"not null pk INT(4)"`
	Pos                  int       `json:"Pos" xorm:"not null pk INT(4)"`
	Actqty               float32   `json:"ActQty" xorm:"not null FLOAT(8)"`
	Orderqtytype         string    `json:"OrderQtyType" xorm:"not null NVARCHAR(40)"`
	Recordtime           string    `json:"RecordTime" xorm:"not null NVARCHAR(28)"`
	Triggerevent         string    `json:"TriggerEvent" xorm:"not null NVARCHAR(80)"`
	Triggerobjectid      string    `json:"TriggerObjectId" xorm:"not null NVARCHAR(80)"`
	Triggersubobjectid   string    `json:"TriggerSubObjectId" xorm:"not null NVARCHAR(80)"`
	Outputstatus         int       `json:"OutputStatus" xorm:"not null INT(4)"`
	Outputevent          string    `json:"OutputEvent" xorm:"not null NVARCHAR(80)"`
	Outputeventmessageid string    `json:"OutputEventMessageId" xorm:"not null NVARCHAR(80)"`
	Outputobjectid       string    `json:"OutputObjectId" xorm:"not null NVARCHAR(80)"`
	Outputsubobjectid    string    `json:"OutputSubObjectId" xorm:"not null NVARCHAR(80)"`
	Remark1              string    `json:"Remark1" xorm:"not null NVARCHAR(200)"`
	Remark2              string    `json:"Remark2" xorm:"not null NVARCHAR(200)"`
	Lastmodify           time.Time `json:"LastModify" xorm:"DATETIME(8)"`
	Lastuser             string    `json:"LastUser" xorm:"not null NVARCHAR(40)"`
	Createtime           time.Time `json:"CreateTime" xorm:"DATETIME(8)"`
}

/******数据表名******/
func (t *OmWooperationqtyreclst) TableName() string {
	return "OmWooperationqtyreclst"
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据添加
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *OmWooperationqtyreclst) Add() error {
	e := db.Eloquent.Master()
	count := new(OmWooperationqtyreclst)
	/**主键：****/
	affw, err := e.Table(t.TableName()).ID(core.PK{t.Plantnr, t.Workorderid, t.Operationnr, t.Splitnr, t.Pos}).Count(count)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table(t.TableName()).Insert(t)

	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据删除
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *OmWooperationqtyreclst) Del() (err error) {
	e := db.Eloquent.Master()
	/**主键：****/
	_, err = e.ID(core.PK{t.Plantnr, t.Workorderid, t.Operationnr, t.Splitnr, t.Pos}).Delete(&OmWooperationqtyreclst{})
	if err != nil {
		return
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据修改
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *OmWooperationqtyreclst) Update() error {
	e := db.Eloquent.Master()
	/**主键：****/
	_, err := e.ID(core.PK{t.Plantnr, t.Workorderid, t.Operationnr, t.Splitnr, t.Pos}).Update(t)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据查找
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *OmWooperationqtyreclst) SelectOne() (OmWooperationqtyreclst, error) {
	e := db.Eloquent.Master()
	var data OmWooperationqtyreclst
	/**主键：****/
	_, err := e.ID(core.PK{t.Plantnr, t.Workorderid, t.Operationnr, t.Splitnr, t.Pos}).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}
