// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.
package models

import (
	"leit.com/aps_engine/db"
	"errors"
	"leit.com/aps_engine/grmi"
	"xorm.io/core"
)

type WorkCalendarLst struct {
	PlantNr        int           `xorm:"pk int 'PlantNr'" json:"WorkCalendarLst-PlantNr"`
	WorkCalendarNr int           `xorm:"pk int 'WorkCalendarNr' autoincr" json:"WorkCalendarLst-WorkCalendarNr"`
	WorkDate       grmi.Date     `xorm:"pk date 'WorkDate'" json:"WorkCalendarLst-WorkDate"`
	DayModelNr     int           `xorm:"int 'DayModelNr' not null" json:"WorkCalendarLst-DayModelNr"`
	LastModify     grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"WorkCalendarLst-LastModify"`
	LastUser       string        `xorm:"nvarchar(20) 'LastUser' not null" json:"WorkCalendarLst-LastUser"`
	CreateTime     grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"WorkCalendarLst-CreateTime"`
}

/******数据表名******/
func (t *WorkCalendarLst) TableName() string {
	return "WorkCalendarLst"
}

/******************************************************************************
 *
 * @Function Name            : GetKey
 *-----------------------------------------------------------------------------
 *
 * @Description              : 获取实体的主键
 *
 * @Return Value             : 实体的主键
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-23 17:06:57
 *
 ******************************************************************************/
func (self *WorkCalendarLst) GetKey() core.PK {
	return core.PK{self.PlantNr, self.WorkCalendarNr, self.WorkDate}
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据添加
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *WorkCalendarLst) Add() error {
	e := db.Eloquent.Master()
	count := new(WorkCalendarLst)
	affw, err := e.Table(t.TableName()).ID(t.GetKey()).Count(count)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table(t.TableName()).Insert(t)

	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据删除
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *WorkCalendarLst) Del() bool {
	e := db.Eloquent.Master()
	_, err := e.ID(t.GetKey()).Delete(&WorkCalendarLst{})
	if err != nil {
		return false
	}
	return true
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据修改
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *WorkCalendarLst) Update() error {
	e := db.Eloquent.Master()
	_, err := e.ID(t.GetKey()).Update(t)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据查找
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *WorkCalendarLst) SelectOne() (WorkCalendarLst, error) {
	e := db.Eloquent.Master()
	var data WorkCalendarLst
	_, err := e.ID(t.GetKey()).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}
