package service

import (
	"leit.com/aps_engine/models"
	"time"
)

/**原材料对象**/
type ArticleSrv struct{
	ArtId		string
	AvailQty	float32
	TransitStockLst	[]models.WmsArttransitstock
	ChangeArray	[]ArticleChangeSrv
	Arttab		models.Article
}

/**原材料消耗及产出**/
type ArticleChangeSrv struct{
	ArtId 			string
	ChangeWay		int 		// 1 = 消耗； 2 = 产出
	ChangeTime 		time.Time	// 变化时间点
	ChangeQty		float32		// 变更数量
	ChangeBeforeQty float32		// 变化之前的数量
	ChangeAfterQty	float32		// 变化之后的数量
	Operation 		*OperationSrv	// 对应的工序任务
}

/**初始化**/
func(as *ArticleSrv)Init(artid string, availqty float32){
	as.ArtId 		= artid
	as.AvailQty		= availqty
	as.ChangeArray 	= []ArticleChangeSrv{}
	as.TransitStockLst = []models.WmsArttransitstock{}
}

/**创建物料对象**/
func(as *ArticleSrv)Create(arttab models.Article){
	as.ArtId 		= arttab.Artid
	as.AvailQty		= 0
	as.ChangeArray 	= []ArticleChangeSrv{}
	as.Arttab		= arttab
	as.TransitStockLst = []models.WmsArttransitstock{}
}

