package service

/**调度事件**/

// 定义事件类型
const(
	// 订单工序事件
	EVENT_TASK_SETUPBEG			= 101
	EVENT_TASK_SETUPEND			= 102
	EVENT_TASK_PLANBEG			= 103
	EVENT_TASK_PLANEND			= 104
	EVENT_TASK_POSTBEG			= 105
	EVENT_TASK_POSTEND			= 106

	// 工位事件
	EVENT_WP_STATUS_AVAIL		= 201
	EVENT_WP_STATUS_UNAVAIL		= 202

	// 工具事件
	EVENT_TOOL_STATUS_AVAIL		= 301
	EVENT_TOOL_STATUS_UNAVAIL	= 302

	// 人员事件
	EVENT_PERSON_STATUS_AVAIL	= 401
	EVENT_PERSON_STATUS_UNAVAIL	= 402

	// 物料事件
	EVENT_ART_CONSUME			= 501	// 物料消耗
	EVENT_ART_YIELD 			= 502	// 物料产出

	// 次要资源事件
	EVENT_SECRES_CONSUME		= 601
	EVENT_SECRES_YIELD  		= 602

)

// 定义事件对象类型
const(
	EVENT_OBJ_ORDER			= 11	// 订单
	EVENT_OBJ_OPTASK		= 12	// 工序任务
	EVENT_OBJ_WPGRP			= 21	// 工位组资源组
	EVENT_OBJ_WP			= 22	// 工位资源
	EVENT_OBJ_TOOLGRP		= 31	// 工具资源组
	EVENT_OBJ_TOOL			= 32	// 工具资源
	EVENT_OBJ_PERSONGRP		= 41	// 人员组
	EVENT_OBJ_PERSON		= 42	// 人员
	EVENT_OBJ_ART			= 51	// 物料类
	EVENT_OBJ_SECRES		= 61	// 次要资源
)

// 定义前后工序接续方式
const(
	OP_LINK_END_START			= "ES"
	OP_LINK_START_START			= "SS"
	OP_LINK_START_START_END_ENT	= "SSEE"
	OP_LINK_END_EACH_START		= "EES"
	OP_LINK_END_START_EACH		= "ESE"
)