package service

import "leit.com/aps_engine/models"

// 工具类型资源组对象
type ToolGrpSrv struct{
	ToolGrpNr		int
	ToolArray		[]ToolSrv			// 工具列表
	ToolIdxDict		map[int]int			// 工具在列表中的索引
	ToolDict 		map[int]*ToolSrv
	WaitTaskArray	[]OperationSrv		// 任务等待队列
	SchedTaskArray	[]SchedTaskSrv		// 已计划任务队列
	ToolGrpTab		models.Toolgrp
}

// 初始化工具组对象
func(tgs *ToolGrpSrv)Init(tgnr int){
	tgs.ToolGrpNr		= tgnr

	tgs.ToolIdxDict		= make(map[int]int)
	tgs.ToolDict		= make(map[int]*ToolSrv)
	tgs.WaitTaskArray	= []OperationSrv{}
	tgs.SchedTaskArray	= []SchedTaskSrv{}
}

// 创建工具组对象
func(tgs *ToolGrpSrv)Create(tgtab models.Toolgrp){
	tgs.ToolGrpNr		= tgtab.Toolgrpnr
	tgs.ToolGrpTab		= tgtab
	tgs.ToolIdxDict		= make(map[int]int)
	tgs.ToolDict		= make(map[int]*ToolSrv)
	tgs.WaitTaskArray	= []OperationSrv{}
	tgs.SchedTaskArray	= []SchedTaskSrv{}
}
