package service

import (
	"leit.com/aps_engine/common"
	"leit.com/aps_engine/models"
)

// 工位组类型资源组对象
type WorkPlaceGrpSrv struct{
	WorkPlaceGrpNr		int
	Wpgtab				models.Workplacegrp
	WorkPlaceDict		map[int]*WorkPlaceSrv
	WaitTaskArray		[]OperationSrv		// 任务等待队列
	SchedTaskArray		[]SchedTaskSrv		// 已计划任务队列
}

// 初始化对象
func(wpgs *WorkPlaceGrpSrv)Init(wpgnr int){
	wpgs.WorkPlaceGrpNr	= wpgnr
	wpgs.WorkPlaceDict	= make(map[int]*WorkPlaceSrv)
	wpgs.WaitTaskArray	= []OperationSrv{}
	wpgs.SchedTaskArray	= []SchedTaskSrv{}
}

// 初始化对象
func(wpgs *WorkPlaceGrpSrv)Create(wpgtab models.Workplacegrp){
	wpgs.WorkPlaceGrpNr	= wpgtab.Workplacegrpnr
	wpgs.Wpgtab			= wpgtab
	wpgs.WorkPlaceDict	= make(map[int]*WorkPlaceSrv)
	wpgs.WaitTaskArray	= []OperationSrv{}
	wpgs.SchedTaskArray	= []SchedTaskSrv{}
}

// 判断工位组内当前是否有工位状态可用
func(wpgs *WorkPlaceGrpSrv)ExistAvailableWorkPlace()(exist bool){
	exist = false
	for _, wp := range wpgs.WorkPlaceDict{
		if wp.Status == common.RES_STATUS_AVAIL {
			exist = true
			return
		}
	}
	return
}


